#include <stdio.h>
#include <stdlib.h>
#include <glib-1.2/glib.h>
#include <glib-1.2/gmodule.h>

#include "sayhello.h"

/* -------------------------------------------------------------- 

  sayhello (part of the shared_lib sample) 
  
  Part of the SourceLib Project at LinuxProgramming.com
  http://www.linuxprogramming.com/SourceLib

  This sample program has been released into the public domain.

  Purpose: Build and use a shared library that contains a single 
  function, sayHello().  This is really just a very fancy version
  of a "hello, world" program.

  Use the command "make" to build this sample.

  See the comments in the file "makefile" for details about how 
  this sample really works.

  ---------------------------------------------------------------

  This is the source for the library, which contains just our 
  single sayHello() function.  Notice that it looks exactly like
  and standard C source file for a separately compiled module.
  All the magic of turning this into a shared library and then 
  using it from another program happens in the make file.

--------------------------------------------------------------- */

/* Change Log:
 *
 * 14 June 02 -  Modified program to load GLIB modules via the g_module
 * API
 *
 * 15 June 02 - Added sayHello_init() function, and sayGoodbye() function;
 *
 */

G_MODULE_EXPORT void sayHello   (gpointer data);
G_MODULE_EXPORT void sayGoodbye (gpointer data);


plugin_callbacks sayhello_callbacks[] = {
  {"Say Hello", "", "Call plug-in function sayHello", sayHello,"hello" },
  {"Say Goodbye","","Call plug-in function sayGoodbye", sayGoodbye,"goodbye" },
};



G_MODULE_EXPORT void
sayHello(gpointer data)
{
  fprintf(stderr,"\tsayHello: You have a message: '%s'\n", (char *)data);
}

G_MODULE_EXPORT void
sayGoodbye(gpointer data)
{
  fprintf(stderr,"\tsayGoodbye: You have a message: '%s'\n", (char *)data);
}

G_MODULE_EXPORT plugin_callbacks *
sayHello_init(char *msg)
{
  printf("%s\n", msg);

  return (sayhello_callbacks);
}

